/*
 *                                 jStock
 *                    (C) Copyright 2003 - 2004, Kaare Ranum
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials
 *      provided with the distribution.
 *
 *   3. Neither the name of Ex Ponto nor the names of its of its
 *      contributors may be used to endorse or promote products
 *      derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


/*
 * Created on 28-Sep-2003
 *
 */
package com.exponto.jstock.popupwindows;
import javax.swing.*;
import java.awt.*;
import javax.swing.table.*;
//import javax.swing.table.AbstractTableModel;
import java.awt.event.*;
import java.util.GregorianCalendar;
import java.text.DateFormat;
import org.apache.log4j.Logger;

import com.exponto.jstock.JstockDB;
import com.exponto.jstock.TickerID;

//import java.awt.event.*;

/**
 * Singleton for notes window, used by all "charts".
 * 
 * @author kaare
 *
 */

//TODO: Add global note area (watchlist),  also needs to save notes on quit
// Also add categorys (follow up, buy sell own buy soon)
public class Notes extends JFrame {
	static private Notes instance; // THE instance of this class
	static Logger logger = Logger.getLogger(Notes.class);
	JPanel controlPanel;
	JPanel mainPanel;
	JSplitPane mainSplit;
	JScrollPane textPane;
	JPanel textPanel;
	JTextArea text;
	
	JScrollPane tablePane;
	JTable table;
	TickerTableModel tableModel;
	TableColumn tickerColumn;
	JComboBox tickerComboBox;
	
	JButton date;
	JButton watch;
	JButton save;
	JButton restore;
	JButton clear;
	JButton close;
	static private JstockDB jDB;
	TickerID currentTID;
//	String ticker;
//	String exchange;
	
	private Notes() {
		super("Notes");
		// Components for the textarea 
		textPane = new JScrollPane();
		textPanel = new JPanel();
		text = new JTextArea("\nAdd your own comments here\n");
		textPanel.add(textPane, BorderLayout.CENTER);
		text.setWrapStyleWord(true);
		text.setEditable(true);
		text.setColumns(25);
		text.setRows(10);
		textPane.getViewport().add(text);
//		Components for the table area
		
		// Test data
		tableModel = new TickerTableModel();
		table = new JTable(tableModel);
		
		tickerColumn = table.getColumnModel().getColumn(0);
		tickerComboBox = new JComboBox();
		for (int i = 0; i < Constants.indicators.length; i++) {
			tickerComboBox.addItem(Constants.indicators[i]);
		}
		tickerComboBox.addItem("Buy (manual override)");
		tickerComboBox.addItem("Hold (manual override)");
		tickerComboBox.addItem("Sell (manual override)");
		tickerComboBox.addItem("None (manual override)");
		//tickerComboBox.setBackground(java.awt.Color.YELLOW);
		tickerColumn.setCellEditor(new DefaultCellEditor(tickerComboBox));
		
		TickerRenderer tickerRenderer = new TickerRenderer();
		tickerRenderer.setToolTipText("Click to adjust buy/sell criteria");
		tickerColumn.setCellRenderer(tickerRenderer);
		
		
		// Not working
		//table.getComponent(0).setBackground(java.awt.Color.green);
//		Not working don't know why
		//table.setPreferredScrollableViewportSize(new Dimension(500, 70));
		// Uncomment next for extended notes window
		//tablePane = new JScrollPane(table);
		
//		The splitpane
//		Uncomment next for extended notes window
//		mainSplit = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, textPane, tablePane);
		// Remove next for extended notes window
		mainSplit = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, textPane, null);
		//mainSplit.add(textPane);
		//mainSplit.add(tablePane);
		mainSplit.setOpaque(true);
		mainSplit.setLeftComponent(textPane);
		mainSplit.setRightComponent(tablePane);
		mainSplit.setResizeWeight(0.5);
		mainSplit.setOneTouchExpandable(true);
		mainSplit.setContinuousLayout(true);
		//mainPanel = new JPanel();
		//mainPanel.setLayout(new FlowLayout());
		//mainPanel.setOpaque(true);
		//mainPanel.add(mainSplit);
		
		controlPanel();
		getContentPane().add(mainSplit, BorderLayout.CENTER);
		//getContentPane().add(textPanel, BorderLayout.CENTER);
		getContentPane().add(controlPanel, BorderLayout.WEST);
		//getContentPane().setOpaque(true);
		//panel.setLayout(new FlowLayout());
		//scrollPane.add(text); 
		pack();
		setVisible(true);
	}
	
	static public Notes getInstance() {
		if (instance==null) {
			instance = new Notes();
		}
		return instance;
	}
	

	static public Notes getInstance(TickerID tID) {
		jDB = JstockDB.getInstance();
		if (instance==null) {
			instance = new Notes();
			instance.setCurrentTID(tID);
		} else {
			instance.save();
			instance.setCurrentTID(tID);
		}
		instance.clear();
		instance.load();
		return instance;
	}


	public void refresh(TickerID tId) {
		logger.debug("Notes: Loaded is " + currentTID.getTickerName() + " " + currentTID.getExchangeName() + " Refreshing " + tId.getTickerName() + " " + tId.getExchangeName());
//	System.out.println("Notes: Loaded is " + ticker + " " + exchange + " Refreshing " + tick + " " + exch + "");
		if (currentTID.getTickerName() !=  tId.getTickerName() || currentTID.getExchangeName() != tId.getExchangeName()) {
			instance.save();
			currentTID = tId;
			//exchange = exch;
			instance.load();
		}
	}
	
	private void save() {
		String s;
		instance.text.selectAll();
		String str = instance.text.getSelectedText();
		if (str != null) {
			s = jDB.saveNotes(currentTID, str);
//			logger.debug("Notes - tried saving");
		} else {
			logger.info("Notes - no text to save");
		}
	}
	

	private void load() {
		String str = jDB.loadNotes(currentTID);
		//System.out.println("str");
		if (str == null || str == " ") {
			instance.text.replaceSelection("\nAdd your own comments here");
		}
		instance.text.selectAll();
		instance.text.replaceSelection(str);
	}

	
	private void clear() {
		text.selectAll();
		text.replaceSelection("");
	}
	private String getCurrentDate() {
		GregorianCalendar cal = new GregorianCalendar();
		java.util.Date date = cal.getTime();
		return DateFormat.getDateInstance().format(date);
	}
	
	private void dbConnection() {
		
	}
	
	/**
	 * @param  tID the TickerID
	 */
	public void setCurrentTID(TickerID tID) {
		currentTID = tID;
	}
	
	
	private void insertText() {
	}

	private void controlPanel() {
		controlPanel = new JPanel();
		controlPanel.setLayout(new GridLayout(5, 1));
		date = new JButton("Date");
		date.setMnemonic(KeyEvent.VK_D);
		watch = new JButton("Watch");
		watch.setMnemonic(KeyEvent.VK_W);
		save = new JButton("Save");
		save.setMnemonic(KeyEvent.VK_S);
		restore = new JButton("Restore");
		restore.setMnemonic(KeyEvent.VK_R);
		clear = new JButton("Clear");
		clear.setMnemonic(KeyEvent.VK_L);
		close = new JButton("Close");
		close.setMnemonic(KeyEvent.VK_Q);
		controlPanel.add(date);
		controlPanel.add(watch);
		controlPanel.add(restore);
		controlPanel.add(clear);
		controlPanel.add(save);
//		controlPanel.add(close);

		date.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				insertDate();
			}
		});
		watch.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				addToWatchList();
			}
		});
		restore.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				load();
			}
		});
		clear.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				empty();
			}
		});
		save.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				save();
			}
		});
		close.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				instance = null;
				//close();
			}
		});

	}
	
	private void insertDate() {
		instance.text.selectAll();
		String str = instance.text.getSelectedText();
		instance.text.replaceSelection(instance.getCurrentDate() +"\n" + str);
//		System.out.println(instance.getCurrentDate());
	}
	private void empty() {
		instance.text.selectAll();
		instance.text.replaceSelection("");
	}
	
	private void addToWatchList() {
		if (currentTID != null) {
			String str = jDB.toggleWatchList(currentTID);
			logger.info("Toggled watchlist for ticker" + str);
		} else {
			logger.error("currentTID is null, don't know what to add");
		}
		
		
		//System.out.println("Class Notes, addToWatchList: " + str);
	}

}
